<?php
// alm 20210913 19:18
/**
 * Exit if accessed directly
 */
if ( !defined( 'ABSPATH' ) ) {
 exit;
}
if ( !class_exists( 'WPQRC_Admin')){

 class WPQRC_Admin {

  public function __construct() {
	global $wpqrc;

	$this->plugin_prefix = $wpqrc->plugin_prefix;
	$this->plugin_textdomain = $wpqrc->plugin_textdomain;

	$this->includes_path = $wpqrc->includes_path;


	//permissions
	$this->plugin_read_capability = $wpqrc->plugin_read_capability;
	$this->plugin_edit_capability = $wpqrc->plugin_edit_capability;
	$this->plugin_params_capability = $wpqrc->plugin_params_capability;
	$this->plugin_settings_capability = $wpqrc->plugin_settings_capability;

	$this->admin_menu_slug = 'wpqrc_admin';
	$this->settings_menu_slug = 'wpqrc_settings';

	// when in admin menu, add admin pages subpage and settings
	add_action( 'admin_menu', array( $this, 'setup_admin_pages' ));

	// when admin initialisation, add settings
	add_action( 'admin_init', array( $this, 'init_options_page' ));




  }

  public function setup_admin_pages() {
		// ajoute les pages d'administration
		// add_menu_page( string $page_title,
		//                string $menu_title,
		//				  string $capability,
		//                string $menu_slug,
		//                callable $function = '',
		//                string $icon_url = '',
		//                int $position = null )
		//https://developer.wordpress.org/resource/dashicons/
		//
		$mp=add_menu_page( __('Wp QR Code',$this->plugin_textdomain),
					   __('Wp QR Code',$this->plugin_textdomain),
					   $this->plugin_read_capability,
					   $this->admin_menu_slug,
					   array($this, 'admin_main_page'),
					   'dashicons-admin-links', // icone  url
					   4 // position
					 );

		// add help to menu page
		add_action('load-'.$mp, array($this, 'main_page_help'));

	}

	public function init_options_page() {
		// get options
		 $options=$this->get_options_tabs('options');
		// registers options groups
		foreach($options as $option) {
		  if(!is_array($option['group'])) {
			register_setting($option['group'],$option['name'],$option['callback']);
		  } else {
			  //print_tab($option);
		   foreach($option['group'] as $i=>$group){
			   register_setting($group,$option['name'][$i],$option['callback'][$i]);
		   }
		  }
		}
	}

	  public function get_options_tabs($info='') {
	  $medias=array(
					 'tabs'=> array(
			  array( 'slug'=>'qrcodes', 'caption'=>__('QrCodes',$this->plugin_textdomain)),
								   ),
					'options'=> array(
			  array( 'group'=>$this->plugin_prefix.'options_qrcr_group', 'name'=>$this->plugin_prefix.'options_qrcr','callback'=>array($this, 'validate_options_qrcr'))),
					 'actions'=> array(
				   )
			);
	  $medias=apply_filters('wpqrc_options_tabs',$medias);
	  switch($info) {
	   case 'tabs':
		$ret=$medias['tabs'];
		break;
	   case 'options':
		$ret=$medias['options'];
		break;
	   case 'actions':
		$ret=$medias['actions'];
		break;
	   default:
		$ret=$medias;
	  }
	  return $ret;
	}

	public function admin_main_page(){
		?>
		<div class="wrap">
        <div class="icon32" id="icon-options-general"><br /></div>
        <h2>
            <?php _e('Fichier de correspondances', $this->plugin_textdomain) ?>
        </h2>
		<h3><?php _e("Voir l'aide à droite", $this->plugin_textdomain) ?></h3>
		</div>
        <h2 class="nav-tab-wrapper">
		   <?php
           //$options=get_option($this->plugin_prefix.'options_subs');
           $this-> manage_file(array(
                   'option'=>$this->plugin_prefix.'options_qrcr',
                   'option_group'=>$this->plugin_prefix.'options_qrcr_group',
                   'title'=>__("Nouveau Fichier csv des correspondances",$this->plugin_textdomain),
                   'change'=>__('Choisir le fichier : ',$this->plugin_textdomain),
                   'update'=>__('Enregistrer le fichier',$this->plugin_textdomain),
           ));
		?>
		</h2>

		<table style="width: 50%; border: 1px solid black">
		<caption><?php _e('Correspondances actives actuellement ',$this->plugin_textdomain); ?></caption>
		<tr>
      <th><?php _e('QRCODE',$this->plugin_textdomain); ?></th>
      <th><?php _e('REDIRECTION',$this->plugin_textdomain); ?></th>
      <th><?php _e('COMMENT',$this->plugin_textdomain); ?></th>
    </tr>
		<?php
		$qrcrs=get_option($this->plugin_prefix.'options_qrcr');
		foreach($qrcrs as $line){
		 echo '
     <tr>
      <td style="border: 1px solid black">'.esc_attr($line['qrcr']).'</td>
      <td style="border: 1px solid black">'.esc_attr($line['url']).'</td>
      <td style="border: 1px solid black">'.esc_attr(($line['comment'])?? '')."</td>
     </tr>\n";
		}
		echo '</table>';
	}

	public function main_page_help(){
	  if (file_exists($this->includes_path.'classes_includes/main_page_help.php')){
		 include($this->includes_path.'classes_includes/main_page_help.php');
	  } else {
		$overview_help = '<p>' . __('Contact site administrator',$this->plugin_textdomain) . '</p>
		<p>' . __('File not found : classes_includes/main_page.php',$this->plugin_textdomain) . '</p>' ;
		get_current_screen()->add_help_tab( array(
		   'id'      => 'overview',
		   'title'   => __('Help Error'),
		   'content' => $overview_help,
		) );
	   }
	}

	public function  manage_file($args) {
	$defs=array(
				'option_group'=>'xxxx',
				'option'=>'xxxx',
				'title'=>__("Image to change",$this->plugin_textdomain),
				'change'=>__('Change image: ',$this->plugin_textdomain),
				'name'=>'options_xxxx_file',
				'max_file_size'=>'500000',
				'update'=>__('Update image',$this->plugin_textdomain),
			   );

	$args=wp_parse_args($args, $defs);

	//print_tab($ar_file);
	?>
	<form enctype="multipart/form-data" method="post" action="options.php" >
	<?php
	settings_fields($args['option_group']);
	echo '<input type="hidden" name="MAX_FILE_SIZE" value="'.esc_attr($args['max_file_size']).'" />';

	?>
	 <div>
	   <table class="form-table">
		<tr>
			<td><?php echo esc_html($args['title']); ?></td>
			<td><?php echo esc_html($args['change']) ?>
			 <input type="file" name="<?php echo esc_attr($args['option']) ?>" />
			</td>
		</tr>
	   </table>
	   <p class="submit">
		<input type="submit" class="button-primary" value="<?php echo esc_html($args['update']); ?>" />
	   </p>
	</div>
	</form>
	<?php
	}

	public function validate_options_qrcr($input){
        $ret = $this->validate_uploaded_csv_file(array(
             'option'=>$this->plugin_prefix.'options_qrcr',
        ));
		write_log($ret);
		return ($ret===false)? get_option($this->plugin_prefix.'options_qrcr') : $ret;
	}

	public function validate_uploaded_csv_file($args){
	   $optionname=$args['option'];
	   if (isset($_FILES[$optionname]) && is_array($_FILES[$optionname])) {
			 $tmp=$_FILES[$optionname];
			 if (isset($tmp['tmp_name']) && is_uploaded_file($tmp['tmp_name']) && (!isset($tmp['error']) || $tmp['error']==UPLOAD_ERR_OK)) {
			  if ($r=@fopen($tmp['tmp_name'], "r")) {
				$qrcrs=array();
				while(!feof($r)){
				 $line=fgets($r);
				 $ar_line=explode(',',$line);
				 if (count($ar_line)<2 || strlen(trim($ar_line[0]))!=20 ) continue;
				 $qrcrs[trim($ar_line[0])]=array(
           'qrcr'=>trim($ar_line[0]), // grcode
           'url'=>trim($ar_line[1]),	// redirect to
           'comment'=>($ar_line[2])?? '', // optionnal comment
         );
				}
				return $qrcrs;
			  } else {
				add_settings_error( $optionname,'TMP_FILE_NOT_READ', __("The temporary file could not be read", $this->plugin_textdomain ));
			  }
			 } else {
			  if (!isset($tmp['tmp_name']))  {
				add_settings_error( $optionname,'TMP_FILE_NAME_NOT_SET',__("The temporary file name was not set", $this->plugin_textdomain ));
			  }
			  if (isset($tmp['tmp_name']) && !empty($tmp['tmp_name']) && !is_file($temp['tmp_name']))  {
				add_settings_error( $optionname,'TMP_FILE_NOT_FOUND',__("The temporary file name was not found", $this->plugin_textdomain ));
			  }

			  if (isset($tmp['error']) && $tmp['error']!=0) {
				 switch ($tmp['error']) {
					case UPLOAD_ERR_INI_SIZE:
						add_settings_error( $optionname,'UPLOAD_ERR_INI_SIZE',__("The uploaded file exceeds the upload_max_filesize directive in php.ini", $this->plugin_textdomain ));
						break;
					case UPLOAD_ERR_FORM_SIZE:
						add_settings_error( $optionname,'UPLOAD_ERR_FORM_SIZE',__("The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form", $this->plugin_textdomain ));
						break;
					case UPLOAD_ERR_PARTIAL:
						add_settings_error( $optionname,'UPLOAD_ERR_PARTIA',__("The uploaded file was only partially uploaded", $this->plugin_textdomain ));
						break;
					case UPLOAD_ERR_NO_FILE:
						add_settings_error( $optionname,'UPLOAD_ERR_NO_FILE',__("No file was uploaded", $this->plugin_textdomain ));
						break;
					case UPLOAD_ERR_NO_TMP_DIR:
						add_settings_error( $optionname,'UPLOAD_ERR_NO_TMP_DIR',__("Missing a temporary folder", $this->plugin_textdomain ));
						break;
					case UPLOAD_ERR_CANT_WRITE:
						add_settings_error( $optionname,'UPLOAD_ERR_CANT_WRITE',__("Failed to write file to disk", $this->plugin_textdomain ));
						break;
					case UPLOAD_ERR_EXTENSION:
						add_settings_error( $optionname,'UPLOAD_ERR_EXTENSION',__("File upload stopped by extension", $this->plugin_textdomain ));
						break;
					default:
						add_settings_error( $optionname,'UPLOAD_ERR_UNKNOWN',__("Unknown upload error", $this->plugin_textdomain ));
						break;
				}
			  } // error #
			 } // read error
			}
		 return false;
	}
 }
}
