<?php

/// alm 20210914 20:11

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

$overview_help = '<p>' . __('Gestion des redirections QRCODE',$this->plugin_textdomain) . '</p>' .
			   '<p>' . __("Ce plugin permet de rediriger vers des destinations (URL) quelconques à partir de liens spécifiques à ce site",$this->plugin_textdomain) . '</p>'.
			   '<p>' . sprintf(__("Le lien initial doit être de la forme %s/qrcr/ABCDEFGHIJABCDEFGHIJ",$this->plugin_textdomain),site_url()) . '</p>'.
			   '<p>' . __("ABCDEFGHIJABCDEFGHIJ est un code de 20 caractères sans espaces qui doit être unique dans la gestion des redirections, la gestion des codes ne fait pas partie du plugin",$this->plugin_textdomain) . '</p>'.
			   '<p>' . __("Le code devrait être généré aléatoirement, afin d'être quasi impossible à deviner : la longueur de 20 devrait être suffisante, elle peut être changée dans le code, mais un changement rendrait les anciens codes inactif",$this->plugin_textdomain) . '</p>'.
			   '<p>' . __("Cette page permet de définir les redirections affectées aux divers QRCODES (ou codes d'une manière générale)",$this->plugin_textdomain) . '</p>';
$use_help = '<p>' . __("Utilisation",$this->plugin_textdomain) . '</p>' .
			   '<p>' . __("Un lien de la forme indiquée doit être fourni à l'utilisateur, soit sur une page web, soit sous forme de QRCODE" ,$this->plugin_textdomain) . '</p>'.
			   '<p>' . sprintf(__("Ce lien ou QRCODE doit donc codé le lien entier %s/qrcr/ABCDEFGHIJABCDEFGHIJ",$this->plugin_textdomain),site_url()) . '</p>'.
				'<p>' . __("Il faut également définir la redirection vers laquelle on va envoyer l'utilisateur, c'est la fonction de cette page",$this->plugin_textdomain) . '</p>'.
				'<p>' . __("Pour cela, on va lire un fichier csv des correspondances CODES,REDIRECTIONS créé extérieurement au plugin (voir onglet formats)",$this->plugin_textdomain) . '</p>'.
				'<p>' . __("Les correspondances seront enregistrées et seront immédiatement actives",$this->plugin_textdomain) . '</p>'.
				'<p>' . __("ATTENTION: les correspondances définies dans le fichier remplacent toutes les correspondances enregistrées, il faut donc pour ajouter de nouvelles correspondances que le nouveau fichier csv contiennent également toutes les anciennes",$this->plugin_textdomain) . '</p>';


$formats_help   = '<p>' . __("Formats",$this->plugin_textdomain) . '</p>' .
			   '<p>' . sprintf(__("Le lien initial doit être de la forme %s/qrcr/ABCDEFGHIJABCDEFGHIJ",$this->plugin_textdomain),site_url()) . '</p>'.
			   '<p>' . sprintf(__("Le QRCODE doit codé le lien complet %s/qrcr/ABCDEFGHIJABCDEFGHIJ",$this->plugin_textdomain),site_url()) . '</p>'.
			   '<p>' . __("ABCDEFGHIJABCDEFGHIJ est un code de 20 caractères sans espaces qui doit être unique dans la gestion des redirections, la gestion des codes ne fait pas partie du plugin",$this->plugin_textdomain) . '</p>'.
			   '<p>' . __("Exemples de codes: ABCDEFGHIJABCDEFGHIJ abcdefghij0123456789 a_b_c_d_e_f_g_h_i_j_",$this->plugin_textdomain) . '</p>'.
			   '<p>' . __("Le fichier csv à fournir est un fichier texte qui contiendra une redirection par ligne, chaque ligne comprenant le code à 20 caractères et le lien vers lequel rediriger l'utilisateur, séparés par une , ",$this->plugin_textdomain) . '</p>'.
			   '<p>' . __("Exemples de lignes : ",$this->plugin_textdomain) . '</p>'.
			   '<p>ABCDEFGHIJABCDEFGHIJ,http://google.fr", commentaires (date signification etc...)</p>'.
			   '<p>abcdefghij0123456789,https:navlab.fr, affiche spéciale noël 2022 </p>';

$page_help   = '<p>' . __("Cette Page",$this->plugin_textdomain) . '</p>' .
			   __("Le tableau en bas de page liste toutes les correspondances CODE/REDIRECTION actives, il est vide avant que l'on charge le premier fichier csv ; si aucune redirection n'est enregistrée, l'utilisateur sera dirigé vers la page d'accueil de ce site",$this->plugin_textdomain) . '</p>'.
			   '<p>' . __('Pour affecter des correspondances (redirections), il faut sélectionner le fichier csv voulu sur son ordinateur grâce au bouton "Parcourir" ; le nom du fichier sélectionné s\'affiche à droite du bouton, on clique alors sur le bouton "Enregistrer le fichier ; les correspondances lues s\'affichent  dans le tableau (ne pas oublier qu\'il faut remettre les anciennes correspondances dans le fichier, sinon elles seront supprimées',$this->plugin_textdomain) . '</p>';

get_current_screen()->add_help_tab(
array(
   'id'      => 'overview',
   'title'   => __('Généralités',$this->plugin_textdomain),
   'content' => $overview_help,
	));

get_current_screen()->add_help_tab(
array(
   'id'      => 'use',
   'title'   => __('Utilisation',$this->plugin_textdomain),
   'content' => $use_help,
	));

get_current_screen()->add_help_tab(
array(
   'id'      => 'formats',
   'title'   => __('Formats',$this->plugin_textdomain),
   'content' => $formats_help,
	));

get_current_screen()->add_help_tab(
array(
   'id'      => 'page',
   'title'   => __('Cette page',$this->plugin_textdomain),
   'content' => $page_help,
	));

/*
get_current_screen()->set_help_sidebar(
	'<p><strong>' . __('For more information:') . '</strong></p>' .
	'<p>' . __('<a href="http://pep2a.fr/societaires/wp-content/uploads/sites/2/2017/06/statuts_scic_pep2a.pdf" target="_blank">Statuts PEP2A</a>') . '</p>'
);
*/
